/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_CONNECTOR_HPP
#define DXC_CONNECTOR_HPP

#include <string>
#include <fstream>
#include <vector>

#include <DxcCallback.hpp>
#include <DxcDataTypes.hpp>
#include <DxcDefs.hpp>

#ifdef _WIN32
#include <Pthreads-w32/pthread.h>
#else
#include <pthread.h>
#endif

namespace Dxc
{
/**
 * @brief Interface for sending and receiving DxcData.
 *
 * A DxcConnector is created via the appropriate call to a ConnectorFactory.
 */
class DXCAPI_EXPORT DxcConnector
{
public:
    virtual void initConnections() = 0;
    /**
     * @brief Sends the DxcData message to the appropriate recipient.
     */
    virtual bool sendMessage(const DxcData *) = 0;
    virtual ~DxcConnector() {};
};
}

#endif
