/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <DataTypes/FaultInjectData.hpp>

using namespace std;
using namespace Dxc;

FaultInjectData::FaultInjectData(Timestamp timestamp,
                                 const Fault& fault,
                                 bool isInjection)
    : DxcData(timestamp),
      isInjection_(isInjection),
      f_(fault)
{
}

FaultInjectData* FaultInjectData::clone() const
{
    return new FaultInjectData(*this);
}

ostream &FaultInjectData::put(ostream &out) const
{
    out << "faultInjection @" << this->getTimeStamp();
    if (this->getSource() != "")
        out << " <" << this->getSource() << ">";
    out << " isInjection = "
        << (this->isInjection() ? "true" : "false");
    out << ", fault = { ";
    out << f_;
    out << " }; " << endl;

    out.flush();

    return out;
}

bool FaultInjectData::isInjection() const
{
    return isInjection_;
}

Fault FaultInjectData::getFault() const
{
    return f_;
}
